import java.util.GregorianCalendar;
import java.util.Random;

import org.apache.commons.codec.binary.Base32;
import org.apache.commons.codec.binary.Hex;

//varianta s pouitm google knihovny Guava
//import com.google.common.io.BaseEncoding;

public class GenerovaniId {

	static private Base32 base32 = new Base32();
	
	static private Random random = new Random();	
	
	private static final String base32Chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567";
	
	public static void main(String[] args) {
		
		//zjitn poadovho sla msce (od ledna 2016) 
		GregorianCalendar dnes = new GregorianCalendar();
		int mesic = dnes.get(GregorianCalendar.MONTH);
		int rok = dnes.get(GregorianCalendar.YEAR) - 2016;
		byte[] poradiMesice = new byte[1];
		poradiMesice[0] = (byte) ((rok * 12) + mesic);
		
		//generovn nhodnho sla
		byte[] nahodneCislo = new byte[5];
		random.nextBytes(nahodneCislo);
		
		//nastaven druhu a verze dokladu - jeden znak z Base32 znakov sady 
		char verzeDruh = 'P'; //P = pedpis verze 201701, V = vdej verze 201701, ...
		
		//sestaven identifiktoru zatm bez kontrolnho soutu
		String idDokladu = verzeDruh + base32.encodeToString(poradiMesice).substring(0, 2) + base32.encodeToString(nahodneCislo);

		//varianta s pouitm google knihovny Guava
		//String idDokladu = verzeDruh + BaseEncoding.base32().omitPadding().encode(casovyInterval) + BaseEncoding.base32().encode(nahodneCislo);
		
		//vpoet kontrolnho soutu
		int kontrolniSoucet = 0; 				
		for (char znak: idDokladu.toCharArray()) {
			kontrolniSoucet = kontrolniSoucet + base32Chars.indexOf(znak);
		}
		
		//konverze kontrolnho soutu na znak v sad Base32
		idDokladu = idDokladu + base32Chars.charAt(kontrolniSoucet % 32);

		//vmna problematickch znak Y a Z za 8 a 9, kter nejsou ve standardn znakov sad base32
		idDokladu = idDokladu.replaceAll("Y", "8").replaceAll("Z", "9");
		
		System.out.println(idDokladu);

		
		
		//zptn dekdovn
		
		//konverze zpt na standardn Base32 znakovou sadu
		idDokladu = idDokladu.replaceAll("8", "Y").replaceAll("9", "Z");

		//oven psupstnosti vslednho kdu dle Base32
		System.out.println(base32.isInAlphabet(idDokladu));

		
		//zjistn druhu dokladu
		verzeDruh = idDokladu.charAt(0);
		System.out.println(verzeDruh);
		
		
		//zjistn poadovho sla msce
		poradiMesice = base32.decode(idDokladu.substring(1, 3));
		System.out.println(((poradiMesice[0] / 12) + 2016) + " " + ((poradiMesice[0] % 12) + 1));
		
		
		//zjistn nhodnho sla (tisk v hexadecimlnm tvaru)
		nahodneCislo = base32.decode(idDokladu.substring(3, 11));
		System.out.println(Hex.encodeHexString(nahodneCislo));
		
		
		//vpoet kontrolnho soutu
		kontrolniSoucet = 0; 				
		for (char znak: idDokladu.substring(0, 11).toCharArray()) {
			kontrolniSoucet = kontrolniSoucet + base32Chars.indexOf(znak);
		}
		
		//oven kontrolnho soutu
		System.out.println((kontrolniSoucet % 32) == base32Chars.indexOf(idDokladu.charAt(11)));

			
	}

}
